/* Copyright 2006, 2007 Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
 * abstract class for initialization request messages. 
 * 
 * @author Young Jin Yoon
 * @see ThincCMsgInit
 */
public abstract class ThincCMsgInitRequest extends ThincCMsgInit {
	public static final int MESSAGE_TYPE = ThincProto2.T_CLIENT_REQ;
	public static final int MESSAGE_SIZE = ThincProto2.T_CLIENT_REQ_SIZE;
	
	public ThincCMsgInitRequest(ThincMsgHandler h, ThincClientCanvas c) {
		super(h, c);
	}
	/**
	 * getMsgType()
	 * 
	 * returns the MESSAGE_TYPE as "client request". 
	 * @return message type for thinc header (client request type in this case)
	 */
	public byte getMsgType() {
		return MESSAGE_TYPE;
	}
}
