/* Copyright 2004, 2006, 2007 Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
 * Common definitions for all of thinc
 *
 * Author:
 * Ricardo Baratto
 * Network Computing Lab - Columbia University
 *
 */
/* set tabstop = 8 */
public interface ThincCommon {


	/* Return values
	 * All functions should use these return values. If you need different, 
	 * or yours have different meaning, define and document them here. Don't 
	 * just use literal numbers or i'll hunt you down */
	public static final int T_OK	= 1;
	public static final int T_ERROR	= -1;

	public static final int T_TRUE	= 1;
	public static final int T_FALSE = 0;
	public static final int T_YES  = T_TRUE;
	public static final int T_NO = T_FALSE;

	/* server defined return values */
	public static final int T_CLOSED  = 0;
	public static final int T_WOULDBLOCK = -2;
	public static final int T_TIMEOUT = -3;

	public static final int T_STOP = 2;	/* stops execution of a message */

	public static final int T_DONE= 1;	/* no more please */
	public static final int T_PART = 2;
	public static final int T_CONT = 0;	/* keep going */

	public static final int T_CLIPPED = 0;	/* command is empty as a result of a modification */
	public static final int T_MERGED = 2;	/* command was merged while trying to queue it */
	public static final int T_COPIED = 2;	/* command had to be copied anyway (thincBufferCmd) */

	public static final int T_EXIT_FAIL = 1;
	public static final int T_EXIT_OK = 0;

}
