/* Copyright 2006, 2007 Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
 * THINC cache protocol specification, JAVA
 * @author Ricardo Baratto
 */

public interface ThincProtoCache {

	/*************************************************************************
	 *                          SERVER => CLIENT                             *
	 *************************************************************************/
	/* T_FB_CACHE_DATA
	 * Description: Wrapper for a cached update. Goes inside an update
	 * message, and tells the client that the data for this particular update
	 * can be found in the cache. The cache id is enclosed in this message.
	 * Size: 4 bytes
	 * Data: None
	 */
	public class thinc_cacheData {
		int cache_id;			//:32
	}

	public static final int T_FB_CACHE_DATA_SIZE = 4;

	/* T_FB_ADD_CACHE:
	 * Description: The update wrapping this message should be added to the
	 * client's cache. The id to use is passed in this message.
	 * Size: 4 bytes
	 * Data: None
	 */
	public class thinc_cacheAdd {
		int cache_id;			//:32
	} 

	public static final int T_FB_CACHE_ADD_SIZE	= 4;


}
