/* Copyright 2006, 2007 Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
 * THINC sound protocol specification, JAVA
 * @author Leo Kim
 */

	/* set tabstop = 8 */
public interface ThincProtoSound {


	/* Message type */
	public static final int T_SND_DATA = 70;
	public static final int T_SND_OPEN = 71;
	public static final int T_SND_PLAY = T_SND_DATA;
	public static final int T_SND_CLOSE = 73;
	public static final int T_SND_VOLUME_DOWN = 74;
	public static final int T_SND_VOLUME_UP = 75;

	/* Data structures */
	/* Tells the client to open its sound card and defines the format of the sound
	 * stream. */
	public class thinc_sndOpen {
		/* for synchronization */
		byte id;
	    short rate;							//		:16;
	    byte bits;							//		:8;
	    byte channels;						//		:8;
	    byte endian;						//      :8;
	    byte pad[] = new byte[3];
	}
	public static final int T_SND_OPEN_SIZE = 6;

	/* support up to 256 (!) streams */
	public class thinc_sndPlay {
	    int size;							//		:32;
		int timestamp;						//		:32;
		byte id;							//		:8;
		byte pad[] = new byte[3];
	}
	public static final int T_SND_PLAY_SIZE = 9;

	public class thinc_sndClose {
		/* Tell which ID to close.*/
		byte id;								//		:8;
		byte pad[] = new byte[3];
	}
	public static final int T_SND_CLOSE_SIZE = 1;

}
