/* Copyright 2006, 2007 Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
import java.nio.ByteBuffer;


/**
 * class for initializing compression method(encoder) for raw images.
 * 
 * @author Young Jin Yoon
 * @see ThincSMsgInitReply
 */
public final class ThincSMsgInitReplyEncoder extends ThincSMsgInitReply {

	public static final int INIT_MESSAGE_TYPE = ThincProto2.T_REQ_ENCODER;
	public static final int MESSAGE_SIZE = ThincProto2.T_REPLY_ENCODER_SIZE;
	
	public static final int MASK = 0x00000003; // for filtering only two bits!
	
	public ThincSMsgInitReplyEncoder(ThincClient tc, ThincMsgHandler h, ThincClientCanvas cs) {
		super(tc, h, cs);
		// TODO Auto-generated constructor stub
	}
	/**
	 * process()
	 * 
	 * gets the encoding option from the server.
	 */
	@Override
	public void process() throws ThincException {
		int encoder;
		ByteBuffer bb;
		/* get the information for encoding from the network */
		try {
			bb = handler.getMessage(MESSAGE_SIZE);
		} catch (ThincException e) {
			throw new ThincException("process: error on Encoder",e);
		}
		encoder = bb.get(); // we will use only two bits in here.
		bb.get(); //discard 3 useless bytes!
		bb.getShort();
		
		/* get first two bits from encoder */
		encoder &= MASK;
		
		/* set it into compression flag message class*/
		ThincSMsgFlagFBZData.set(encoder);
	}

}
