/* Copyright 2006, 2007 Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
import java.util.Hashtable;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.SourceDataLine;
/**
 * abstract class for sound messages. 
 * 
 * @author Young Jin Yoon
 * @see ThincSMsg
 */
public abstract class ThincSMsgSound extends ThincSMsg {

	protected static final AudioFormat.Encoding ENCODING = AudioFormat.Encoding.PCM_SIGNED;
		//encoding information for sound

	private static final int MAX_SND_STREAM = 256; // max sound stream for client 

	protected static Hashtable streamId = new Hashtable(MAX_SND_STREAM); 
		//hash table to save the stream information
	
	protected static AudioFormat format; 			 // AudioFormat object in Java
	protected static final int SAMPLE_SIZE = 16;	 // sampling size
	protected static final float FRAME_RATE = 44100;//44100; // frame rate (may be as same as sampling rate)
	protected static SourceDataLine.Info playInfo;   // Info object for sound in Java

	public ThincSMsgSound(ThincSoundHandler h) {
		super(h, null);
//		format = new AudioFormat((int)(rate & 0xffff),(int)(bits & 0xff),(int)(channels & 0xff),true,isEndian);
//        playInfo = new DataLine.Info(SourceDataLine.class, format);
		format = null;
		playInfo = null;
	}
}
