/* Copyright 2006, 2007 Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
import java.util.Vector;
/**
 * abstract class for video messages. 
 * 
 * @author Young Jin Yoon
 * @see ThincSMsg
 */
public abstract class ThincSMsgVideo extends ThincSMsg {
	/* video type supported by THINC for detailed information,
	 * see http://www.fourcc.org and derived class of ThincVideoFormat.*/
	public static final int YV12 = ThincProtoVideo.T_FOURCC_YV12;
	public static final int YUY2 = ThincProtoVideo.T_FOURCC_YUY2;
	public static final int UYVY = ThincProtoVideo.T_FOURCC_UYVY;

	protected static Vector streamId = new Vector(4); // vector to save the stream information
	protected class ThincVideoStream { // contents in the vector
		int x = 0; // x of video stream
		int y = 0; // y of video stream
		int width = 0; // original width of video stream
		int height = 0; // original height of video stream
		int dst_width = 0; // resized width of video stream
		int dst_height = 0; // resized height of video stream
		int timestamp = 0; // recent timestamp of video stream
		boolean firstFlag = false; // is first stream? (to get the first timestamp)
		ThincVideoFormat format = null; // ThincVideoFormat object to handle the different video type
	}
	
	public ThincSMsgVideo(ThincMsgHandler h, ThincClientCanvas c) {
		super(h, c);
	}
}
