/* Copyright 2004, 2006, 2007 Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
 * Defines an interface to allow an Exception to wrap another Exception and
 * guarantee that clients can test for and access those nested Exceptions.
 * Notably implemented by <code>{@link ExceptionWrapper}</code>, but the 
 * existence of this interface allows any Exception to implement it with any 
 * constructors or access methods.
 *
 * @author Leo Kim
 * @version 1.3
 * @see ExceptionWrapper
 */

public interface WrappableException {

    /**
     * Allow access to the enclosed Exception.
     *
     * @return null if no enclosed Exception.
     */

    public Exception getEnclosedException();

}
