/* Copyright 2004, 2005, 2007 Ricardo Baratto */
/* Copyright 2004, 2005, 2007 Columbia University */
/*
 * Region abstraction for thinc client
 *
 * Ricardo Baratto
 * Network Computing Lab - Columbia University
 */

/*
 * XXX XXX XXX
 * HACK: Stealing region definition in xfree86's xlib so that we can
 * look "inside" of it and manipulate in ways not provided by xlib.
 * May break with other implementations. 
 * FIXME FIXME We need a decent region API!! Should use pixman library
 */

#ifndef _TC_REGION_H_
#define _TC_REGION_H_

#include <X11/Xutil.h>

typedef struct {
	short x1, x2, y1, y2;
} tc_xlib_box;

/* Region. It's supposed to be the same as an xlib region so we can
 * exchange between the two at will */
typedef struct {
	long size;
	long numRects;
	tc_xlib_box *rects;
	tc_xlib_box extents;
} tc_xlib_rgn;

#define tc_rgn_numrects(rgn) \
	((rgn)->numRects)

#define tc_rgn_rects(rgn) \
	((rgn)->rects)

#define tc_rgn_extents(rgn) \
	(&(rgn)->extents)

#define tc_rgn_extents_rect(rgn, rectp) \
	tc_box_to_rect(tc_rgn_extents(rgn), rectp);

#define tc_box_to_rect(bp, rp) \
	(rp)->x = (bp)->x1; \
	(rp)->y = (bp)->y1; \
	(rp)->width = tc_box_width(bp); \
	(rp)->height = tc_box_height(bp); \

#define tc_box_width(bp) \
	( ( (bp)->x1 == (bp)->x2 ) ? 1 : (bp)->x2 - (bp)->x1 )

#define tc_box_height(bp) \
	( ( (bp)->y1 == (bp)->y2 ) ? 1 : (bp)->y2 - (bp)->y1 )

inline void tc_rgn_convert(const tc_xlib_box *boxes, XRectangle *rects, int n);

inline void tc_region_resize(struct tc_fb *fb, Region r);
inline void tc_rgn_resize(struct tc_fb *fb, tc_xlib_rgn *rgn);
inline void tc_resize_scale_box(struct tc_fb *fb, tc_xlib_box *box);
inline void tc_resize_augment_box(struct tc_fb *fb, tc_xlib_box *box,
	int x, int y);

#endif
