/* Copyright 2002, 2003, 2004, 2005, 2007 Ricardo Baratto */
/* Copyright 2002, 2003, 2004, 2005, 2007 Columbia University */
/*
 * Header file for X11 THINC client
 *
 * Author:
 * Ricardo Baratto
 * Network Computing Lab - Columbia University
 */

/* set tabstop = 8 */

#ifndef _TC_X11_H_
#define _TC_X11_H_

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/XShm.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <string.h>

#define TCLIENT_TITLE "thinc client"

/* TODO: Use nicer names */
struct tc_x11 {
	Display *disp;
	Window Main;
	GC theGC;
	Pixmap DesktopP;
	Visual *visual;
	XImage *img;
	Cursor theCursor;
	int w_depth;
	int use_shm;
	XShmSegmentInfo shminfo;
	Region damageRgn;
	/* need different region due to scaling */
	Region exposeRgn;
	int resized;
	Pixmap resizedP;
	/* resizedRgn is the region, in 'resized' coordinates, which has
	 * been changed with resized RAW updates. Its contents should
	 * be copied from resizedP to the main window. This region is
	 * only valid during one loop iteration. */
	Region resizedRgn;
	unsigned int updated:1;
	unsigned int exposed:1;
	/* from rdesktop */
	unsigned int focused:1;
	unsigned int mouse_in:1;
};

struct tc_fillHandle {
	Pixmap pix;
	GC gc;
};

inline void tc_x11_setclip_region(struct tc_fb *fb, Region reg);
void tc_x11_setclip(struct tc_fb *fb, tc_xlib_rgn *rgn);
inline void tc_x11_clearclip(struct tc_fb *fb);

inline void tc_resize_scale_rect(struct tc_fb *fb, XRectangle *rect);
inline void tc_resize_augment_rect(struct tc_fb *fb, XRectangle *rect,
	int x, int y);
inline int tc_resize_update_region(struct tc_fb *fb, const Region r, 
	const Region rz);
int tc_resize_update_region_rects(struct tc_fb *fb, const Region r, 
	const Region rz);
int tc_resize_update_rgn(struct tc_fb *fb, const tc_xlib_rgn *rgn, 
	const tc_xlib_rgn *rgn_rsz);

int tc_resize_update_rect(struct tc_fb *fb, XRectangle *orig, XRectangle *rszd);
int tc_resize_update_box(struct tc_fb *fb,tc_xlib_box *orig,tc_xlib_box *rszd);
inline void tc_resize_scale_region(struct tc_fb *fb, Region reg);
inline int tc_resize_unscale_numx(struct tc_fb *fb, int num);
inline int tc_resize_unscale_numy(struct tc_fb *fb, int num);
inline void tc_resize_img_outdated(struct tc_fb *fb);

#endif	/* _TC_X11_H_ */
